procedure newt(var x: vector; n: integer; var check: boolean);

const
     maxits = 200;
     tolf = 1.0e-4;
     tolmin = 1.0e-6;
     tolx = 1.0e-7;
     stpmx = 100.0;

var
    i,its,j                          : integer;
    indx                             : glindx;
    d,den,f,fold,sum,temp,test,stpmax: double;
    fjac                             : glnpbynp;
    p                                : glnarray;
    xold, g                          : vector;

begin
    nn:= n;
    f:= fmin(x);
    test:= 0.0;
    for i:= 1 to n do if(abs(fvec[i]) > test) then test:= abs(fvec[i]);
    if(test < 0.01*TOLF) then exit;
    sum:= 0.0;
    for i:= 1 to n do sum:= sum+x[i]*x[i];
    stpmax:=STPMX*max(sqrt(sum),n);
    for its:= 1 to MAXITS do begin
        fdjac(n,x,fvec,fjac);
        for i:= 1 to n do begin
            sum:= 0.0;
            for j:= 1 to n do sum:= sum+fjac[j,i]*fvec[j];
            g[i]:= sum;
        end;
        for i:= 1 to n do xold[i]:= x[i];
        fold:= f;
        for i:= 1 to n do p[i]:= -fvec[i];
        ludcmp(fjac,n,NP,indx,d);
        lubksb(fjac,n,NP,indx,p);
        lnsrch(n,xold,fold,g,p,x,f,stpmax,check);
        test:= 0.0;
        for i:= 1 to n do if(abs(fvec[i]) > test) then test:= abs(fvec[i]);
        if (test < TOLF) then begin
           check:= false;
           exit;
        end;
        if (check) then begin
           test:= 0.0;
           den:= max(f,0.5*n);
           for i:= 1 to n do begin
               temp:= abs(g[i])*max(abs(x[i]),1.0)/den;
               if (temp > test) then test:= temp;
           end;
           if (test < TOLMIN) then
              check:= true
           else
              check:= false;
           exit;
        end;
        test:= 0.0;
        for i:= 1 to n do begin
            temp:= (abs(x[i]-xold[i]))/max(abs(x[i]),1.0);
            if (temp > test) then test:= temp;
        end;
        if (test < TOLX) then exit;
    end;
    writeln('MAXITS exceeded in newt');
    halt;
end;
